package eu.dnetlib.ariadneplus.elasticsearch.model;

import com.google.gson.Gson;
import org.apache.lucene.spatial3d.geom.GeoShape;
import org.elasticsearch.common.geo.GeoPoint;

import java.util.List;


public class Spatial {
    private String placeName;
    private String address;
    private GeoPoint geopoint;
    private String boundingbox;
    private String polygon;
    private String spatialPrecision;
    private String coordinatePrecision;

    private transient String boundingBoxMaxLat;
    private transient String boundingBoxMaxLon;
    private transient String boundingBoxMinLat;
    private transient String boundingBoxMinLon;
    private transient String lat;
    private transient String lon;
    private transient List<AriadneGeoPoint> polygonGeoPoints;
    private transient String wkt;

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getBoundingBoxMaxLat() {
        return boundingBoxMaxLat;
    }

    public void setBoundingBoxMaxLat(String boundingBoxMaxLat) {
        this.boundingBoxMaxLat = boundingBoxMaxLat;
    }

    public String getBoundingBoxMaxLon() {
        return boundingBoxMaxLon;
    }

    public void setBoundingBoxMaxLon(String boundingBoxMaxLon) {
        this.boundingBoxMaxLon = boundingBoxMaxLon;
    }

    public String getBoundingBoxMinLat() {
        return boundingBoxMinLat;
    }

    public void setBoundingBoxMinLat(String boundingBoxMinLat) {
        this.boundingBoxMinLat = boundingBoxMinLat;
    }

    public String getBoundingBoxMinLon() {
        return boundingBoxMinLon;
    }

    public void setBoundingBoxMinLon(String boundingBoxMinLon) {
        this.boundingBoxMinLon = boundingBoxMinLon;
    }

    public String getPlaceName() {
        return placeName;
    }

    public void setPlaceName(String placeName) {
        this.placeName = placeName;
    }

    public String getSpatialPrecision() {
        return spatialPrecision;
    }

    public void setSpatialPrecision(String spatialPrecision) {
        this.spatialPrecision = spatialPrecision;
    }

    public String getCoordinatePrecision() {
        return coordinatePrecision;
    }

    public void setCoordinatePrecision(String coordinatePrecision) {
        this.coordinatePrecision = coordinatePrecision;
    }

    public String getLat() {
        return lat;
    }

    public void setLat(String lat) {
        this.lat = lat;
    }

    public String getLon() {
        return lon;
    }

    public void setLon(String lon) {
        this.lon = lon;
    }

    public String getBoundingbox() {
        return boundingbox;
    }

    public void setBoundingbox(String boundingbox) {
        this.boundingbox = boundingbox;
    }

    public GeoPoint getGeopoint() {
        return geopoint;
    }

    public String getPolygon() {
        return polygon;
    }

    public void setPolygon(String polygon) {
        this.polygon = polygon;
    }

    public void setGeopoint(GeoPoint geopoint) {
        this.geopoint = geopoint;
    }

    public List<AriadneGeoPoint> getPolygonGeoPoints() {
        return polygonGeoPoints;
    }

    public void setPolygonGeoPoints(List<AriadneGeoPoint> polygonGeoPoints) {
        this.polygonGeoPoints = polygonGeoPoints;
    }

    public String getWkt() {
        return wkt;
    }

    public void setWkt(String wkt) {
        this.wkt = wkt;
    }

    public Spatial() {
    }

    public static Spatial fromJson(String json){
        return new Gson().fromJson(json, Spatial.class);
    }
}
